;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ---------------------------------------------------------------------------
;;;; File name: gc-preds.lsp
;;;;    System: LTRE
;;;;   Version: 4.1
;;;;    Author: John Everett
;;;;   Created: May 1, 1986
;;;;  Modified: everett on Fri Jul 26 15:12:35 1996
;;;;   Purpose: Garbage collection predicates
;;;; Copyright: 1986, 1989, 1990, 1991, 1995 Kenneth D. Forbus, 
;;;;            Northwestern University, and Johan de Kleer, Xerox Corporation.
;;;;            All Rights Reserved.
;;;; ---------------------------------------------------------------------------

(in-package :LTRE)


;;; GARBAGE COLLECTION PREDICATE
;;; ----------------------------------------------------------------------------
;;; GC-able-node? is used at runtime, but the ltre-gc-test function that the 
;;; LTRE user must supply is also called at rule-compilation time.

(defun gc-able-node? (node &optional (*ltre* *ltre*))
   "Used during fact garbage collection"
   (and (unknown-node? node)
        (funcall (ltre-gc-test *ltre*) (view-node node))))

(defun default-gc-p (form)
   "Default filler for ltre-gc-test slot, gcs nothing"
   (declare (ignore form))
   nil)
   
;;; ----------------------------------------------------------------------------
;;; END OF CODE